/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.logic;


import engcalculator.data.Interval;
import engcalculator.function.infix.DualInputSingleOutputInfixFunction;
import engcalculator.function.infix.compare.NotEqual;

/**
 *
 * @author simone
 */
public abstract class LogicInfixFunction extends DualInputSingleOutputInfixFunction {
    private final static Interval TRUE = new Interval ( new Interval (1));
    private final static Interval FALSE = new Interval ( new Interval (0));
    private final static Interval FALSEINTERVAL = new Interval (0);
    private final static NotEqual NOTEQUAL = new NotEqual();

    public LogicInfixFunction(String name, String help, String[] examplesleft, String[] examplesright, String[] results) {
        super(name, true, true, help, examplesleft, examplesright, results);
    }

    @Override
    public final Interval _computeIntervals(Interval leftSide, Interval rightSide) throws Exception {
        if (compare (NOTEQUAL.compare(leftSide, FALSEINTERVAL), NOTEQUAL.compare(rightSide, FALSEINTERVAL))) return TRUE;
        else return FALSE;
    }

    public abstract boolean compare (boolean a, boolean b) throws Exception;

}
