/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.logarithm;


import engcalculator.data.Interval;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public abstract class Logarithm extends SingleInputSingleOutputPrefixFunction {

    public Logarithm(String name, String help, String[] examples, String[] results) {
        super (name, true,true, help, examples, results);
    }


    @Override
    public final Interval _computeIntervals(Interval a) throws Exception {
        if (a.getLeft() <= 0) throw new CalculusException ("Logarithm cannot computer interval negative");
        return new Interval ( __compute(a.getLeft()),  __compute(a.getRight()));
    }

    public abstract double __compute (double val) throws Exception;

}
