/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.set;


import engcalculator.data.Interval;
import engcalculator.function.infix.compare.ComparisonInfixFunction;

/**
 *
 * @author simone
 */
public class SubSet extends ComparisonInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"6_7","6_7", "1_2", "3_4"};
    private final static String[] EXAMPLE_RIGHT = {"5_8","7_8", "1.5_3", "-3_-2"};
    private final static String[] RESULT = {"1","0","0","0"};

    public SubSet() {
        super("<<", "<< checks if an interval is a subset of another returning 0 for false, 1 for true. Subset means every element of the firs interval is available in the second (the opposit is not required).", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public boolean compare(Interval a, Interval b) throws Exception {
        return  a.getLeft() >= b.getLeft() && a.getRight() <= b.getRight();
    }
}
