/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.system;

import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;
import java.util.Random;
/**
 *
 * @author simone
 */
public class Rand extends SingleInputSingleOutputPrefixFunction {
    private final static String[] EXAMPLE = {"10_10"};
    private final static String[] RESULT = {"10"};
    private final Random random = new Random();
    
    public Rand() {
        super("random", true, true, "Returns a random number contained in the given interval.", EXAMPLE, RESULT);
    }
    
    @Override
    public Interval _computeIntervals (Interval i) throws Exception {
        return new Interval (random.nextDouble()*i.getRange()+i.getLeft());
    }
}
